<template>
  <div>
    <h3>{{displayMonth()}}</h3>
    <v-sheet
      tile
      height="54"
      color="grey lighten-3"
      class="d-flex"
    >
    <!-- Change de mois gauche -->
      <v-btn
        icon
        class="ma-2"
        :ripple="false"
        @click="$refs.calendar.prev()"
      >
        <v-icon>mdi-chevron-left</v-icon>
      </v-btn>
      <v-spacer></v-spacer>
      <v-btn dense class="ma-2" :ripple="false" @click="displayEditEvent()" 
        v-show="user"
      >
        <v-icon>mdi-plus</v-icon>
      </v-btn>
      <v-spacer></v-spacer>
      <v-btn dense :ripple="false" class="ma-2" @click="focusToday()">Aujourd'hui</v-btn>
      <v-spacer v-show="user"></v-spacer>
      <v-select
        v-model="selectedUsersFilters"
        :items="calendarUsers"
        dense
        background-color="#f5f5f5"
        outlined
        multiple
        class="ma-2 selectWidth"
        label="Trier par utilisateur"
      >
      <template v-slot:selection="{ item, index }">
          <span v-if="index === 0">{{ item }}</span>
        <span
          v-if="index === 1"
          class="grey--text caption"
          
        >{{`+${selectedUsersFilters.length - 1} autre`}}</span>
      </template>
      </v-select>
      <v-select
        v-model="type"
        :items="types"
        dense
        background-color="#f5f5f5"
        outlined
        class="ma-2 selectWidth"
        label="Affichage"
      >
      </v-select>
      <v-spacer></v-spacer>
    <!-- Change de mois droite -->
      <v-btn
        icon
        class="ma-2"
        @click="$refs.calendar.next()"
      >
        <v-icon>mdi-chevron-right</v-icon>
      </v-btn>
    </v-sheet>
    <v-sheet height="90vh">
      <v-calendar
        ref="calendar"
        v-model="value"
        :weekdays="weekday"
        :type="type"
        :events="filteredEvents"
        :event-overlap-mode="mode"
        :event-overlap-threshold="30"
        :event-color="getEventColor"
        @click:event="displayEventDetails"
        @click:more="viewDay"
        @click:date="viewDay"
      ></v-calendar>
    </v-sheet>
    <CalendarPopOver v-if="displayDialog && selectedEvent !== null" :event="selectedEvent" @isClose="closeInfoModal" @reloadEvents="getAllEvents" @displayEditEvent="displayEditEvent"/>
    <EditEventModal v-if="showEditEventModal" @isClose="closeEditModal" :event="selectedEvent" :dialog="showEditEventModal"/>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import EventService from '../../services/eventService';
import CalendarPopOver from './CalendarPopOver.vue';
import EditEventModal from './EditEventModal.vue';
import CalendarEvent from '../../transport/CalendarEvent';
import { mapState } from "vuex";
import { User } from '../../transport/User';


@Component({
  computed:{
    ...mapState([
      'user'
    ])},
  components: {
    Calendar,
    CalendarPopOver,
    EditEventModal
  }
})
export default class Calendar extends Vue{
  type= 'month';
  types= [{text: 'Mois', value: 'month'}, {text: 'Semaine', value: 'week'}, {text: 'Jour', value: 'day'}, {text: '4 jours', value: '4day'}];
  mode= 'column';
  value= '';
  weekday= [1, 2, 3, 4, 5, 6, 0];
  events: CalendarEvent[] = [];
  selectedUsersFilters: User[] = [];
  selectedEvent: CalendarEvent = null;
  displayDialog: boolean = false;
  showEditEventModal: boolean = false;
  
  mounted(){
    this.getAllEvents();
  }

  getAllEvents(){
    this.selectedEvent = null;
    return new EventService().getAll()
    .then(events => this.events = events)
    .then(() => this.selectedUsersFilters = this.calendarUsers)
  }
  /**
   * Contient tous les objets uniques users des utilisateurs ayant un évènement.
   */
  get calendarUsers(): User[]{
    return this.events.map(event => event.data.user)
    .reduce((x, y) => 
      x.findIndex(e=>e._id ==y._id)<0 ?
       [...x, y]:
        x, []
      )
  }
  /**
   * Evènements appartenant à un utilisateur spécifié dans le filter
   */
  get filteredEvents(){
    // return this.events;
    return this.events.filter(e => {
      return this.selectedUsersFilters.find(item => item._id === e.data.user._id)
    })
  }
  getEventColor(event: CalendarEvent){
    return event.data.user.color;
  }

  viewDay ({date}) {
    this.value = date;
    this.type = 'day'
  }
  focusToday(){
    this.value = 'today';
    this.type = 'month';
  }
  displayEventDetails({ event }){
    this.displayDialog = true;
    this.selectedEvent = event;
  }
  closeInfoModal(){
    this.displayDialog = false;
    this.selectedEvent = null;
  }
  closeEditModal(){
      this.showEditEventModal = false;
      // TimeOut pour bug graphique
      setTimeout(() => {
        this.closeInfoModal();
        this.getAllEvents();
      }, 500);
  }
  displayEditEvent(){
    this.displayDialog = false;
    this.showEditEventModal = true;
  }

  displayMonth(){
    if(this.value && this.value !== 'today'){
   return new Intl.DateTimeFormat('fr-FR', { month: 'long', year: 'numeric'}).format(Date.parse(this.value)).toUpperCase()
    }
    return new Intl.DateTimeFormat('fr-FR', { month: 'long', year: 'numeric'}).format(Date.now()).toUpperCase()
  }
}
</script>

<style>
.selectWidth{
  width: 10%
}
</style>
